%Function outputs the matrix that gives all the combinations of the isotopes of current atom type in the compound whose mass == sumOfLabels
%naturalAbundances = naturalAbundances of different isotopes of current atom. Only length of the vector is really required
%atomCount = number of atoms of current type in the compound
%sumOfLabels = targetted total mass 

function y = CalculateMultmatrix(naturalAbundances, atomCount, sumOfLabels)
 

   if sumOfLabels == 0 % handle this as special case
       y = atomCount;
   else

   maxLabel = length(naturalAbundances) - 1; %maximal weigth of atom (m+maxLabel)

   if maxLabel > sumOfLabels % forget too heavy isotopomers
       maxLabel = sumOfLabels;
   end

       
   if atomCount * maxLabel < sumOfLabels
       myError('Impossible to form required isotopomer combination!','Error in CalculateMultProb');
   end
   
       
   resultMatrix = zeros(0, maxLabel + 1); 
   
   % start filling resultMatrix by adding combinations where is one "big" isotopomer and required amount of +1 isotopomers
   
   numOfOnes = 0;
   
   for j = 1 : maxLabel - 1
       
       tempVect = zeros(1,maxLabel + 1);
       
       numOfOnes = sumOfLabels - (maxLabel - j + 1);   % how many +1 isotopomers are required?
       
       if numOfOnes + 1 <= atomCount % are there enough atoms for this combination?
           tempVect(maxLabel - j + 2) = 1; % add number of big isotopomers
           tempVect(2) = numOfOnes; % add number of +1's
           tempVect(1) = atomCount - numOfOnes - 1;  % add number of +0's
           resultMatrix = cat(1,resultMatrix,tempVect);
       end
   end
   
   % add combination where that consists of +1's and +0's
   if atomCount >= sumOfLabels
       tempVect = zeros(1,maxLabel + 1);
       tempVect(2) = sumOfLabels;
       tempVect(1) = atomCount - sumOfLabels;
       resultMatrix = cat(1,resultMatrix,tempVect);
   end
   
   %generate  the rest of combinations by combining +1's in current resultMatrix
   
   k = size(resultMatrix,1);
   
   for j = 1 : k 
       
       numOfOnes = resultMatrix(j,2);
       numOfZeros = resultMatrix(j,1);
       biggestIso = sumOfLabels - numOfOnes;
       
       for subst = biggestIso : -1 :2
           temp = numOfOnes - subst;
           m = 1;
           
           while temp >= 0
               tempVect = zeros(1, maxLabel + 1);
               tempVect(2) = temp;
               tempVect(biggestIso + 1) = 1;
               tempVect(subst + 1) = tempVect(subst + 1) + m; % possibility of adding result written in previos line
               tempVect(1) = atomCount - sum(tempVect);
               resultMatrix = cat(1,resultMatrix,tempVect);
               temp = temp - subst;
               m = m + 1;
           end;
       
       end
   end
   
   y = resultMatrix;
end %if        
       
           
       
       
       
       
   
   


