%Function calculates probability of certain atom type of non labelled part of the compound having certain amount of extra neutrons using multinomial factorial
%naturalAbundances = natural abundences of different isotopes of current atom type
%atomCount = number of atoms of current atom type in the compound
%sumOfLabels = targetted amount of extra neutrons
function y = CalculateMultProb(naturalAbundances, atomCount, sumOfLabels)

  multVect = zeros(1,length(naturalAbundances));
  multiFactMatrix = CalculateMultMatrix2(naturalAbundances, atomCount, sumOfLabels, multVect, atomCount);
  
  sum = 0;
  
  
  for i = 1 : size(multiFactMatrix,1)
      tempDiv = 1;
      tempPow = 1;
      
      for j = 1 : size(multiFactMatrix,2)
          tempDiv = tempDiv * factorial(multiFactMatrix(i,j));
          tempPow = tempPow * naturalAbundances(j) ^ multiFactMatrix(i,j);
      end
      
      sum = sum + ((factorial(atomCount) / tempDiv) * tempPow);
  end
  
  y = sum;
  
       
        
       
   
   


