% Function that calculates Posiotional isotopomer distribution 
function y = CalculatePosIsotops(origAbundances)


  %first struct in fragmentArray represents whole molecule
  %masses are normalized to the sum of masses of all isotopomers
  global isLastUnderDetermined;
  global fragments;
  global epsilon;
  
  numOfCarbons = length(fragments{1}.carbons);  %amount of carbons in the molecule
  intensityVector = fragments{1}.intensities;
  temp = length(intensityVector) - (numOfCarbons + 1);
  
  if temp < 0 
      tempVect = zeros(-temp,1);
      intensityVector = cat(1,intensityVector,tempVect);
  end
  if temp > 0
      intensityVector = intensityVector(1:numOfCarbons +1);
  end    
  
  multiplicationMatrix = CreateFullMatrix(numOfCarbons);
  origMultMatrix = multiplicationMatrix;
  
  
  %create multiplication and mass matrices
  for i = 2: length(fragments)
      fragMultMatrix = CreateFragmentMatrix(i,numOfCarbons,origAbundances); 
      multiplicationMatrix = cat(1,multiplicationMatrix,fragMultMatrix);
      
      temp = length(fragments{i}.intensities) - size(fragMultMatrix,1);     
     % if fragments{i}.peak == -1 % is zooming isu used extra intensities are the heaviest ones ONKO OIKEIN???
        
       intensityVector = cat(1, intensityVector, fragments{i}.intensities);
      
        if temp < 0  
            tempVect = zeros(-temp,1);
            intensityVector = cat(1,intensityVector,tempVect);
        end
      
        if temp > 0 
          intensityVector = intensityVector(1:length(intensityVector) - temp);    
        end
        
        %else %zooming is used
       %  if temp > 0
       %      lengthOfI = length(fragments{i}.intensities);
       %      tempVect = fragments{i}.intensities(temp + 1 :lengthOfI);
             
       %  else
       %     tempVect = cat(1, fragments{i}.intensities, zeros(-temp,1));
       % end
       % intensityVector = cat(1,intensityVector,tempVect);    
       %end
          
 end
  
  %ready for solving linear equations!
  
  %tranform constraints to independent equations
  
  multMatOrth = (orth(multiplicationMatrix'))';
  lsqSol = pinv(multiplicationMatrix)*intensityVector;
  
  intensityVector = multMatOrth*lsqSol; 
  
  
  if rank(multiplicationMatrix) < size(multiplicationMatrix,2) %underdetermined equation
     %nullSpace = null(multiplicationMatrix,'r'); 
     %h = warndlg('Equations are underdetermined!','Warning');
     %drawnow;
     %set(h,'WindowStyle','modal');
     
     isLastUnderDetermined = 1;
 else
     isLastUnderDetermined = 0;
 end
% y = FindDepedencies(multMatOrth,intensityVector);
 sol = rref(horzcat(multMatOrth,intensityVector));
 %remove intensities close to zero
 temp = find(abs(sol(:,size(sol,2))) < eps);
 sol(temp,size(sol,2)) = 0;
 
 y = sol;
 
 
    %else
     %I = multiplicationMatrix \ intensityVector;
     %tempEye = eye(size(multiplicationMatrix,2));
     %I = cat(2,tempEye,I);
     %isLastUnderDetermined = 0;
     
  
  
 
 
  
  
  
  
  