%Check if spectra of fragment contains wrong amount of peaks. Only chechking and warning is done here, correction is done elsewhere

function y = CheckSpectras(fragNum, labelIndex, intensities)

global fragments;
wrongNumberOfPeaksWarning =' ';

  
if fragments{fragNum}.peak == -1  %fragment produced by simultaeous fragmenting
    if intensities(1) == 0
         wrongNumberOfPeaksWarning = strcat(wrongNumberOfPeaksWarning,strcat(strcat(' +0-peak missing in fragment number: ',int2str(fragNum)),'. '));    
    end
    if length(intensities) > length(fragments{1}.intensities)
        wrongNumberOfPeaksWarning = strcat(wrongNumberOfPeaksWarning,strcat(strcat(' Too many peaks in the spectrum of fragment number: ',int2str(fragNum)),'. '));    
    end  
    
else  %fragment produced by daughter ion scanning
    if intensities(1) == 0
         wrongNumberOfPeaksWarning = strcat(wrongNumberOfPeaksWarning,strcat(strcat(' +0-peak missing in fragment number: ',int2str(fragNum)),'. '));    
    end   
    if length(intensities) > fragments{fragNum}.peak + 1
        %wrongNumberOfPeaksWarning = strcat(wrongNumberOfPeaksWarning,strcat(strcat(' Too many peaks in the spectrum of fragment number: ',int2str(fragNum)),'. '));    
        myError(strcat(' Too many peaks in the spectrum of fragment number: ',int2str(fragNum)), 'Error in CheckSpectras');  
    end
    if fragments{fragNum}.peak >= length(fragments{1}.intensities)
        wrongNumberOfPeaksWarning = strcat(wrongNumberOfPeaksWarning,strcat(strcat(' Selected non-existent peak for daughter ion scanning: ',int2str(fragNum)),'. '));   
    end
    %MIT TSS PITISI TEHD???
    %t = fragments{fragNum}.peak - (length(fragments{1}.carbons) - fragments{fragNum}.atomCount(labelIndex));
    
    %for i = 1 : t
    %    if intensities(i) > 0
    %        wrongNumberOfPeaksWarning = strcat(wrongNumberOfPeaksWarning,strcat(strcat('Too low peaks in the spectra of fragment number: ',int2str(fragNum)),'. '));    
    %        break;
    %    end
    %end
end


y = wrongNumberOfPeaksWarning;