% function creates coefficient matrix to calculate positional isotopomer distribution that corresponds to original product
% numOfCarbons = number of atoms of labelled atom type
function y = CreateFullMatrix(numOfCarbons)

    global combinatorialMatrix;
    combinatorialMatrix = CreateCombMatrix(numOfCarbons);
    
    
    sumVector = sum (combinatorialMatrix);
    
    rowCount = numOfCarbons + 1;
    colCount = 2 ^ numOfCarbons; 
    
    matrix = zeros(numOfCarbons + 1, 2 ^ numOfCarbons);
    
    for i = 1: numOfCarbons + 1;
        for j = 1: 2 ^ numOfCarbons
            if sumVector(j) == i - 1;
                matrix(i,j) = 1;
            end
        end
    end
    
    y = matrix;
    