%helper function that formats the output of FindDepedencies
function y = CreateResultMatrix(M, centers, isotopCount)

    resMat = zeros(0,isotopCount + 1);
    
    %find independent isotopomers
    
    indIsot = zeros(1,0);
    for i = 1 : length(centers)
        if centers(i) == 0
            indIsot = cat(2,indIsot,i);
        end
    end
            
    
    
    for i = 1 : length(centers)
        if centers(i) ~= 0
            tempVect = zeros(1,isotopCount + 1);
            tempVect(i) = 1;
            for j = 1 : size(M,2) - 1
                if M(centers(i),j) ~= 0
                    tempVect(indIsot(j)) = - M(centers(i),j);
                end
            end
            tempVect(isotopCount + 1) = M(centers(i),size(M,2));
            resMat = cat(1,resMat,tempVect);
        end
    end
    
    y = resMat;